<template>
  <teleport to="body">
    <div>
      <div v-if="show" @click="tryClose" class="backdrop"></div>
      <transition name="pop-login-modal">
        <dialog open v-if="show">
          <div class="card">
            <h5 class="card-header">{{ title }}</h5>
            <div class="card-body">
              <h5 class="card-title">Login failed!</h5>
              <p>An error occurred during authentication!</p>
            </div>
          </div>
          <button type="button" class="btn btn-primary" @click="tryClose">Continue</button>
        </dialog>
      </transition>
    </div>
  </teleport>
</template>

<script>
export default {
  data() {
    return {
      fixed: false,
    };
  },
  props: {
    show: {
      type: Boolean,
      required: true,
    },
    title: {
      type: String,
      required: false,
    },
  },
  emits: ['close'],
  methods: {
    tryClose() {
      // close without logging in - by clicking on backdrop
      if (this.fixed) { // todo - check if this will be used at all
        return;
      }
      this.$emit('close');
    },
  },
};
</script>

<style scoped>
.backdrop {
  position: fixed;
  top: 0;
  left: 0;
  height: 100vh;
  width: 100%;
  background-color: rgba(0, 0, 0, 0.75);
  z-index: 10;
}

dialog {
  position: fixed;
  top: 20vh;
  left: 10%;
  width: 80%;
  z-index: 100;
  border-radius: 12px;
  border: none;
  box-shadow: 0 2px 8px rgba(0, 0, 0, 0.26);
  padding: 0;
  margin: 0;
  overflow: hidden;
  background-color: white;
}

.invalid-form {
  color: red;
}

.pop-login-modal-enter-from {
  opacity: 0;
  transform: translateY(-40px);
}

.pop-login-modal-enter-to {
  opacity: 1;
  transform: translateY(0);
}

.pop-login-modal-enter-active {
  transition: all 0.4s ease-out;
}

.pop-login-modal-leave-from {
  opacity: 1;
  transform: translateY(0);
}

.pop-login-modal-leave-to {
  opacity: 0;
  transform: translateY(-40px);
}

.pop-login-modal-leave-active {
  transition: all 0.3s ease-in;
}

@media (min-width: 768px) {
  dialog {
    left: calc(50% - 20rem);
    width: 40rem;
  }
}
</style>
